import { CdktfProject } from "../../../../lib/";
import { NestedTerraformOutputs } from "../../../../lib/output";
export declare type LogEntry = {
    content: string;
    id: string;
    stackName: string;
};
declare type CdktfProjectOpts = {
    onOutputsRetrieved?: (outputs: any) => void;
    outDir: string;
    synthCommand: string;
};
export declare function useCdktfProject<T>(opts: CdktfProjectOpts, projectCallback: (project: CdktfProject) => Promise<T>): {
    done: boolean;
    logEntries: LogEntry[];
    outputs: {
        [key: string]: import("../../../../lib/models/terraform").TerraformOutput;
    } | {
        [key: string]: NestedTerraformOutputs;
    } | undefined;
    projectUpdate: {
        type: "planning";
        stackName: string;
    } | {
        type: "planned";
        stackName: string;
        plan: import("../../../../lib/models/terraform").TerraformPlan;
    } | {
        type: "deploying";
        stackName: string;
    } | {
        type: "deploy update";
        stackName: string;
        deployOutput: string;
        resources: import("../../../../lib/models/terraform").DeployingResource[];
    } | {
        type: "deployed";
        stackName: string;
        outputsByConstructId: NestedTerraformOutputs;
        outputs: Record<string, any>;
    } | {
        type: "destroying";
        stackName: string;
    } | {
        type: "destroy update";
        stackName: string;
        destroyOutput: string;
        resources: import("../../../../lib/models/terraform").DeployingResource[];
    } | {
        type: "destroyed";
        stackName: string;
    } | {
        type: "outputs fetched";
        stackName: string;
        outputsByConstructId: NestedTerraformOutputs;
        outputs: Record<string, any>;
    } | {
        type: "waiting for approval";
        stackName: string;
        plan: import("../../../../lib/models/terraform").TerraformPlan;
        approve: () => void;
        dismiss: () => void;
        stop: () => void;
    } | {
        type: "synthesizing";
    } | {
        type: "synthesized";
        stacks: import("../../../../lib").SynthesizedStack[];
        errorMessage?: string | undefined;
    } | undefined;
    returnValue: T | undefined;
};
export {};
